 ; Ŀ
 ;   Bic - place lights in a space.                                        
 ;   Copyright 1997, 2006, 2010 by Rocket Software Ltd.                    
 ;   Before generating any information, ask what use it will be.           
 ;   If nobody knows, ask for a promotion.                                 
 ; 
 (DEFUN C:BIC (/ osmo *error* pa pb xdis ydis rows cols rowdis coldis px py
                                  rowlis collis colptx num rowpty pta ptlist)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (if (or (null wasp) (null misps))
      (load "misps"))
  (setq osmo (getvar "osmode"))
  (defun *error* (shk)
   (setvar "osmode" osmo)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (write-line shk))
  (princ))
  (setvar "osmode" 33)
  (setq pa (getpoint "\nCorner of space: "))
  (setq pb (getcorner pa "\nOther corner: "))
  (setvar "osmode" osmo)
  (setq xdis (- (car pb) (car pa)))
  (setq ydis (- (cadr pb) (cadr pa)))
  (setq rows (getint "\nNumber of rows: "))
  (setq cols (getint "\nNumber of columns: "))
  (setq rowdis (/ ydis rows))
  (setq coldis (/ xdis cols))
  (setq px (+ (car pa) (/ coldis 2)))
  (setq collis (list px))
  (repeat (1- cols)
          (setq collis (append collis (list (setq px (+ px coldis))))))
  (setq py (+ (cadr pa) (/ rowdis 2)))
  (setq rowlis (list py))
  (repeat (1- rows)
          (setq rowlis (append rowlis (list (setq py (+ py rowdis))))))
  (while (setq colptx (car collis))
         (setq collis (cdr collis))
         (setq num 0)
         (while (setq rowpty (nth num rowlis))
                (setq num (1+ num))
                (setq pta (list colptx rowpty))
                (setq ptlist (append ptlist (list pta)))))
  (setq num 0)
  (while (setq pta (nth num ptlist))
         (setq num (1+ num))
         (command ".insert" "pendant-light" pta (misps) "" 0))
  (*error* ())
 (princ))
