 ; Ŀ
 ;   Blaz - Put a catch permit into a drawing with no tb.                  
 ;   Copyright 1994, 2001, 2003, 2004, 2006 - 2014 by Rocket Software Ltd. 
 ;                                                                         
 ; 

 ; Ŀ
 ;   Draed - erase and purge blocks named in a list.                       
 ;   Arguments: Blist, a list of block names.                              
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN DRAED (blist / blnam ss)
  (while blist
         (setq blnam (car blist))
         (setq blist (cdr blist))
         (if (and blnam (setq ss (ssget "X" (list (cons 2 blnam)))))
             (command ".erase" ss ""))
         (if blnam (command "-purge" "block" blnam "n")))
 (princ))
 ; Ŀ
 ;   Draed end.                                                            
 ; 

 ; Ŀ
 ;   Blaz.                                                                 
 ; 
 (DEFUN C:BLAZ (/ osna entt pa ss xoff yoff)
  (setvar "cmdecho" 1)
  (setq osna (getvar "osmode"))
  (setvar "osmode" 0)
  (if (setq ss (ssget "x" (list (cons 0 "text") (cons 1 "BLACKSTONE DEHY"))))
      (progn
           (setq entt (entget (ssname ss 0)))
           (setq pa (cdr (assoc 10 entt)))
           (setq xoff 23.6)
           (setq yoff 0.25)
           (setq pb (polar (polar pa pi xoff) (* pi 1.5) yoff))
           (command "insert" "catchpermit" pb "0.075" "" "")
           (c:np)
           (draed (list "catchpermit")))
      (progn
           (load "perm" ())
           (c:perm)))
  (setvar "osmode" osna) 
 (princ))