 ; Ŀ
 ;   DimLeft - make the Left isometric dimstyle.                           
 ;   Made in Acad 18.1s (LMS Tech) - dimvars may differ in other releases. 
 ;   Copyright 2013 by Rocket Software Ltd.                                
 ;   Laser printers are ok, but wouldn't you rather have a laser rifle?    
 ; 
 (DEFUN C:DIMLEFT (/ stnam)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq stnam "Left")
  (command "DIMADEC"   0                ; Angular decimal places
           "DIMALT"    0                ; Alternate units selected
           "DIMALTD"   2                ; Alternate unit decimal places
           "DIMALTF"   25.400000000000  ; Alternate unit scale factor
           "DIMALTRND" 0.000000000000   ; Alternate units rounding value
           "DIMALTTD"  2                ; Alternate tolerance decimal places
           "DIMALTTZ"  0                ; Alternate tolerance zero suppression
           "DIMALTU"   2                ; Alternate units
           "DIMALTZ"   0                ; Alternate unit zero suppression
 ;         "DIMANNO"   0                ; Is style annotative? (Read Only)
           "DIMAPOST"  ""               ; Prefix and suffix for alternate text
           "DIMARCSYM" 0                ; Arc symbol display
           "DIMASO"    1                ; Create dimensions as one entity - obsolete
           "DIMASSOC"  2                ; Tie dimension objects to geometry
           "DIMASZ"    3.000000000000   ; Arrow size
           "DIMATFIT"  3                ; Arrow and text fit
           "DIMAUNIT"  0                ; Angular unit format
           "DIMAZIN"   0                ; Angular zero supression
           "DIMBLK"    ""               ; Arrow block name
           "DIMBLK1"   ""               ; First arrow block name
           "DIMBLK2"   ""               ; Second arrow block name
           "DIMCEN"    2.000000000000   ; Center mark size
           "DIMCLRD"   6                ; Dimension line and leader color
           "DIMCLRE"   8                ; Extension line color
           "DIMCLRT"   2                ; Dimension text color
           "DIMDEC"    0                ; Decimal places
           "DIMDLE"    0.000000000000   ; Dimension line extension
           "DIMDLI"    10.000000000000  ; Dimension line spacing
           "DIMDSEP"   "."              ; Decimal separator
           "DIMEXE"    2.000000000000   ; Extension above dimension line
           "DIMEXO"    2.000000000000   ; Extension line origin offset
           "DIMFIT"    3                ; Obsolete
           "DIMFXL"    1.000000000000   ; Total length of extension lines
           "DIMFXLON"  0                ; Are extension lines fixed length?
           "DIMJOGANG" 45.000000000000  ; Angle of jog
           "DIMLTEX1"  "ByLayer"        ; Extension line 1 linetype
           "DIMLTEX2"  "ByLayer"        ; Extension line 2 linetype
           "DIMLTYPE"  "ByLayer"        ; Dimension line linetype
           "DIMFRAC"   0                ; Fraction format
           "DIMGAP"    2.000000000000   ; Gap from dimension line to text
           "DIMJUST"   0                ; Justification of text on dimension line
           "DIMLDRBLK" ""               ; Leader block name
           "DIMLFAC"   1.000000000000   ; Linear unit scale factor
           "DIMLIM"    0                ; Generate dimension limits
           "DIMLUNIT"  2                ; Linear unit format
           "DIMLWD"    -2               ; Dimension line and leader lineweight
           "DIMLWE"    -2               ; Extension line lineweight
           "DIMPOST"   ""               ; Prefix and suffix for dimension text
           "DIMRND"    0.000000000000   ; Rounding value
           "DIMSAH"    0                ; Separate arrow blocks
 ;         "DIMSCALE"  1.000000000000   ; Overall scale factor
           "DIMSD1"    0                ; Suppress the first dimension line
           "DIMSD2"    0                ; Suppress the second dimension line
           "DIMSE1"    0                ; Suppress the first extension line
           "DIMSE2"    0                ; Suppress the second extension line
           "DIMSHO"    1                ; Update text while dimension is dragged
           "DIMSOXD"   0                ; Suppress outside dimension lines
           "DIMTAD"    0                ; Place text above the dimension line
           "DIMTDEC"   0                ; Tolerance decimal places
           "DIMTFAC"   1.000000000000   ; Tolerance text height scaling factor
           "DIMTIH"    0                ; Text inside extensions is horizontal
           "DIMTIX"    0                ; Place text inside extensions
           "DIMTM"     0.000000000000   ; Minus tolerance
           "DIMTMOVE"  0                ; Text movement
           "DIMTOFL"   1                ; Force line inside extension lines
           "DIMTOH"    0                ; Text outside horizontal
           "DIMTOL"    0                ; Tolerance dimensioning
           "DIMTFILL"  0                ; Use dimension text backgrounds
           "DIMTFILLCLR" 0              ; Dimension text background colour
           "DIMTOLJ"   1                ; Tolerance vertical justification
           "DIMTP"     0.000000000000   ; Plus tolerance
           "DIMTSZ"    0.000000000000   ; Tick size
           "DIMTVP"    0.000000000000   ; Text vertical position
           "DIMTXSTY"  "IsoLeft"        ; Text style
           "DIMTXT"    2.500000000000   ; Text height
           "DIMTZIN"   3                ; Tolerance zero suppression
           "DIMUNIT"   2                ; Obsolete
           "DIMUPT"    0                ; User positioned text
           "DIMZIN"    3)               ; Zero suppression
  (if (tblsearch "dimstyle" stnam)
      (command "dimstyle" "save" stnam "y")
      (command "dimstyle" "save" stnam))
  (command "undo" "end")
 (princ))
