 ; Ŀ
 ;   Hl - hatch last.                                                      
 ;   Yl - yellow last.                                                     
 ;   Trl - tray last.                                                      
 ;   Copyright 1996, 1997, 2002, 2004 - 2010 by Rocket Software Ltd.       
 ;   You may not be trying to accomplish what you think you are.           
 ; 
 (DEFUN C:YL (/ *error*)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (defun *error* (shk)
   (if shk (write-line shk))
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
  (command "change" (entlast) "" "p" "color" "yellow" "")
  (command "undo" "end")
 (princ))

 (DEFUN C:HL (/ *error* hasc clay enam)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq clay (getvar "clayer"))
  (defun *error* (shk)
   (setvar "clayer" clay)
   (if shk (write-line shk))
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
 ; Ŀ
 ;   Load Misps.lsp, which contains the ps/ms scaling subroutines.         
 ; 
  (if (or (null wasp) (null misps))
      (if (null (load "misps" ()))
          (prompt "\n** The File Misps.lsp Is Not Available. **\n")))
  (setq hasc (* (misps) 25))
  (if (tblsearch "layer" "hatch")
      (setvar "clayer" "hatch")
      (command "layer" "m" "hatch" "c" 6 "" ""))
  (setq enam (entlast))
  (command "hatch" "ansi31" hasc "0" enam "")
  (setvar "clayer" clay)
  (command "undo" "end")
 (princ))

(DEFUN C:TRL (/ *error* hasc clay enam)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq clay (getvar "clayer"))
  (defun *error* (shk)
   (setvar "clayer" clay)
   (if shk (write-line shk))
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
 ; Ŀ
 ;   Load Misps.lsp, which contains the ps/ms scaling subroutines.         
 ; 
  (if (or (null wasp) (null misps))
      (if (null (load "misps" ()))
          (prompt "\n** The File Misps.lsp Is Not Available. **\n")))
  (setq hasc (* (misps) 25))
  (if (tblsearch "layer" "tray")
      (setvar "clayer" "tray")
      (malaya "tray"))
  (setq enam (entlast))
  (command "change" (entlast) "" "p" "la" "tray" "")
  (command "hatch" "dots" hasc "0" enam "")
  (setvar "clayer" clay)
  (command "undo" "end")
 (princ))
