 ; Ŀ
 ;   Htm - make a test html file.                                          
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;                                                                         
 ; 
 (DEFUN C:HTM (/ headls endlis htmlis clos totlis ss num enam entt blnam sub
                 suba totls pa scal rota space linn datlis htmls2 prefa fn ff
                                                                        stra)
 ; Ŀ
 ;   Make the html header and end lists.                                   
 ; 
  (setq headls (list "<body bgcolor=\"#336699\" text=\"#FFFFCC\">"
                     "<center><br>"))
  (setq endlis (list "</center>"
                     "<br><br>"))
 ; Ŀ
 ;   Make the block data table header and end line lists.                  
 ; 
  (setq htmlis (list "<font size=\"6\"><b>Block Data</b></font>"
                     "<br><br>"
                     "<table border=\"1\">"
                     "<colgroup align=\"center\" width=\"125\"></colgroup>"
                     "<tr><td>Block Name</td><td>Insertion</td>"
                     "<td>Scale</td><td>Rotation</td><td>Space</td></tr>"))
  (setq clos (list "</table>"
                   "<br><br>"))
 ; Ŀ
 ;   Make the Total table header list.                                     
 ; 
  (setq totlis (list "<font size=\"6\"><b>Totals</b></font>"
                     "<br><br>"
                     "<table border=\"1\">"
                     "<colgroup align=\"center\" width=\"125\"></colgroup>"
                     "<tr><td>Block Name</td><td>Insertions</td></tr>"))
 ; Ŀ
 ;   Get an ss of all blocks in the drawing.                               
 ; 
  (if (setq ss (ssget "x" (list (cons 0 "insert"))))
      (progn
           (setq num 0)
 ; Ŀ
 ;   Extract the data for each one.                                        
 ; 
           (while (setq enam (ssname ss num))
                  (setq num (1+ num))
                  (setq entt (entget enam))
                  (setq blnam (cdr (assoc 2 entt)))
                  (setq blnam (strcat (strcase (substr blnam 1 1))
                                      (strcase (substr blnam 2) t)))
 ; Ŀ
 ;   Save block counts.                                                    
 ; 
                  (if (setq sub (assoc blnam totls))
                      (progn
                           (setq suba (cons blnam (1+ (cdr sub))))
                           (setq totls (subst suba sub totls)))
                      (setq totls (cons (cons blnam 1) totls)))
 ; Ŀ
 ;   Extract other individual insertion data.                              
 ; 
                  (setq pa (cdr (assoc 10 entt)))
                  (setq pa (strcat (rtos (car pa) 2 2) ","
                                   (rtos (cadr pa) 2 2)))
                  (setq scal (cdr (assoc 41 entt)))
                  (setq scal (rtos scal 2 2))
                  (setq rota (cdr (assoc 50 entt)))
                  (setq rota (rtos (* (/ 180 pi) rota) 2 2))
                  (setq space (cdr (assoc 410 entt)))
 ; Ŀ
 ;   Add each line to the html table data list.                            
 ; 
                  (setq linn (strcat "<tr><td>" blnam "</td>"
                                         "<td>" pa    "</td>"
                                         "<td>" scal  "</td>"
                                         "<td>" rota  "</td>"
                                         "<td>" space "</td></tr>"))
                  (setq datlis (append datlis (list linn))))
 ; Ŀ
 ;   Loop end, add the closing html lines to the list.                     
 ; 
           (setq datlis (append htmlis datlis clos))
 ; Ŀ
 ;   Make the second table line list.                                      
 ; 
           (while (setq sub (car totls))
                  (setq totls (cdr totls))
                  (setq linn (strcat "<tr><td>" (car sub) "</td>"
                                         "<td>" (itoa (cdr sub)) "</td></tr>"))
                  (setq htmls2 (append htmls2 (list linn))))
 ; Ŀ
 ;   Add it the total table header and close lists.                        
 ; 
           (setq totlis (append totlis htmls2 clos))
 ; Ŀ
 ;   Make the entire html file list set: header, two tables, close.        
 ; 
           (setq htmlis (append headls totlis datlis endlis))
 ; Ŀ
 ;   Open the file to write to.                                            
 ; 
           (setq prefa (getvar "dwgprefix"))
           (setq fn (strcat prefa "Blocks.htm"))
           (setq ff (open fn "w"))
 ; Ŀ
 ;   Write the html lines.                                                 
 ; 
           (setq num 0)
           (while (setq stra (nth num htmlis))
                  (setq num (1+ num))
                  (write-line stra ff))
 ; Ŀ
 ;   Close the file, end.                                                  
 ; 
           (if ff (close ff))
           (command "start" "firefox.exe blocks.htm")))
 (princ))