 ; Ŀ
 ;   Layupp - set the layer state from the file Layers.txt if it is        
 ;   found in the directory with the current drawing.                      
 ;   Copyright 2012 by Rocket Software Ltd.                                
 ;   Ignores layer names not exactly matching those in the file.           
 ;                                                                         
 ; 
 (DEFUN C:LAYUPP (/ *error* fnam fillst)
  (setvar "cmdecho" 0)
  (defun *error* (shk)
   (print shk)
  (princ))
  (if (null (load "bungee" ()))
      (prompt "\n** Bungee.lsp Can't Be Loaded. **\n"))
 ; Ŀ
 ;   Get the list of layer states from the config file Layers.txt.         
 ; 
  (if (setq fnam (findfile (strcat (getvar "dwgprefix") "layers.txt")))
      (progn
 ; Ŀ
 ;   Indicate which Layers.txt file was used.                              
 ; 
           (prompt (strcat "\nUsing Layer data File: " fnam))
 ; Ŀ
 ;   And update the layers if the data is available.                       
 ; 
           (if (setq fillst (fst fnam))
               (blisso fillst)
               (write-line "* Abort: no status list in file *"))))
 (princ))