 ; Ŀ
 ;   Misps: get a scale factor: 1 in PS, Dimscale in MS or a vport.        
 ;   If the global variable Scalps is t the PS scale is also dimscale.     
 ;   Copyright 2009, 2010 by Rocket Software Ltd.                          
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Wasp - are we in the Model Space Tab, Paper Space, or      
 ;   a viewport in Paper Space?                                            
 ;   Brooks no Arguments.                                                  
 ;   Calls nothing.                                                        
 ;   Returns: 1 - Model space.                                             
 ;            2 - Paper space.                                             
 ;            3 - A Viewport in Paper Space.                               
 ; 
 (DEFUN WASP ()
  (cond ((= (getvar "tilemode") 1) 1)
        ((= (getvar "cvport") 1) 2)
        (t 3)))
 ; Ŀ
 ;   Wasp end.                                                             
 ; 

;(setq scalps t)

 ; Ŀ
 ;   Misps.                                                                
 ;   The variable Scalps must be global.                                   
 ; 
 (defun MISPS (/ scaalf scapa)
  (setq scaalf (getvar "dimscale"))
  (setq scapa (wasp))
  (cond (scalps scaalf)  ; scalps is set so always dimscale
        ((= scapa 1)     ; ms
         scaalf)
        ((= scapa 2)     ; ps
         1.0)
        ((= scapa 3)     ; viewport in ps
         scaalf)
        (t scaalf)))     ; no idea - use dimscale


(princ)