 ; Ŀ
 ;   Plost - see if a drawing is in named or coloured plot style mode.     
 ;   Copyright 2004 by Rocket Software Ltd.                                
 ;                                                                         
 ; 
 ; Ŀ
 ;   According to the manual if the current drawing is in colour           
 ;   dependent plot mode then PstylePolicy is set to 1.                    
 ;   This doesn't work.                                                    
 ;   But the Cplotstyle sysvar "controls the current plot style for new    
 ;   objects."  If you are in color-dependent mode then CplotStyle is      
 ;   read-only and has a value of "Bycolor."  If the drawing is in named   
 ;   plot styles mode then CplotStyle can be set to the following values:  
 ;   Bylayer (the default), Byblock, Normal, or User Defined.              
 ;   So we can deduce which state the drawing is in and convert it to      
 ;   colour dependent mode (with ConvertPstyles) if necessary.             
 ;   Converting the other way can wait until colour plotters become more   
 ;   common.  Or idiots become more influential.                           
 ;   Convertpstyles asks for a named (.stb) penweight file when going to   
 ;   named plot styles, but doesn't ask for one going to coloured.         
 ; 
 (DEFUN C:PLOST ()
  (setvar "cmdecho" 0)
  (if (/= (strcase (getvar "cplotstyle") t) "bycolor")
      (progn
           (write-line "Converting drawing to plot by colour.")
           (command "convertpstyles")))
 (princ))