 ; Ŀ
 ;   Pussy - subroutines: find out how big an ss is, or a block.           
 ;   Contains (Puss) - find out how big a block is.                        
 ;            (Pussy) - find out how big an ss is.                         
 ;            (P1ssy) - box a single entity.                               
 ;            Pussy - test program for (pussy).                            
 ;            Pt - test program for (puss).                                
 ;            (Bent) - find the insertion & limits of a block definition.  
 ;            Bent - test program for (bent).                              
 ;                                                                         
 ;   And a whack of subroutines.                                           
 ;                                                                         
 ;   Copyright 1996, 2001, 2006, 2008, 2011, 2012 by Rocket Software Ltd.  
 ;                                                                         
 ; 


 (defun c:thest (/ mxlst)
  (setq mxlst (ahatch (cdr (assoc -1 (entget (car (entsel "Hatch: ")))))))
  (bop mxlst 2 1)
 (princ))

 (defun c:test (/ mxlst)
  (setq mxlst (puss (cdr (assoc -1 (entget (car (entsel "Block: ")))))))
  (bop mxlst 2 1)
 (princ))


 ; Ŀ
 ;   Subroutine Ahatch - box a hatch.                                      
 ; 
 (DEFUN AHATCH (enam / entt tchnum subx suby xmax xmin ymax ymin num)
  (setq entt (entget enam))
 ; hatch boundary data varies, apparently depending on the boundary path
 ; type.  This is listed in the boundary path type flag, 92.
 ; Boundary path type flag (bit coded):
 ; 0 = Default
 ; 1 = External
 ; 2 = Polyline
 ; 4 = Derived
 ; 8 = Textbox
 ; 16 = Outermost
 ; This solution is based on two obsereved cases and should be checked
 ; and made more general.
  (setq tchnum (if (= (cdr (assoc 92 entt)) 1) 11 10))
  (setq num 0)
  (while (setq sub (nth num entt))
         (setq num (1+ num))
         (if (and (= (car sub) tchnum)
                  (not (equal sub (list tchnum 0.0 0.0 0.0))))
             (progn
                  (setq subx (cadr sub))
                  (setq suby (caddr sub))
                  (if (or (null xmax) (> subx xmax))
                      (setq xmax subx))
                  (if (or (null xmin) (< subx xmin))
                      (setq xmin subx))
                  (if (or (null ymax) (> suby ymax))
                      (setq ymax suby))
                  (if (or (null ymin) (< suby ymin))
                      (setq ymin suby)))))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Ahatch end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Arb - box an arc given the ename.                          
 ; 
 (DEFUN ARB (enam / entt cen rad stangl endang cwend ccwend xmax xmin ymax
                                                                      ymin)
  (setq entt (entget enam))
  (setq cen (cdr (assoc 10 entt)))
  (setq rad (cdr (assoc 40 entt)))
  (setq stangl (cdr (assoc 50 entt)))
  (setq endang (cdr (assoc 51 entt)))
  (setq cwend (polar cen stangl rad))
  (setq ccwend (polar cen endang rad))
 ; Ŀ
 ;   See if the arc crosses its (y=0, x>=0) axis.                          
 ; 
  (if (< stangl endang)
      (progn
           (setq xmax (max (car cwend) (car ccwend)))
 ; Ŀ
 ;   Decide which of the other quadrants are on the arc and thus deduce    
 ;   the max and min x and y points.                                       
 ; 
           (if (and (< stangl pi) (> endang pi))
               (setq xmin (- (car cen) rad))
               (setq xmin (min (car cwend) (car ccwend))))
           (if (and (< stangl (/ pi 2)) (> endang (/ pi 2)))
               (setq ymax (+ (cadr cen) rad))
               (setq ymax (max (cadr cwend) (cadr ccwend))))
           (if (and (< stangl (* pi 1.5)) (> endang (* pi 1.5)))
               (setq ymin (- (cadr cen) rad))
               (setq ymin (min (cadr cwend) (cadr ccwend)))))
      (progn
           (setq xmax (+ (car cen) rad))
 ; Ŀ
 ;   Decide which of the other quadrants are on the arc and thus deduce    
 ;   the max and min x and y points.                                       
 ; 
           (if (or (and (> stangl pi) (> endang pi))
                   (and (< stangl pi) (< endang pi)))
               (setq xmin (- (car cen) rad))
               (setq xmin (min (car cwend) (car ccwend))))
           (if (or (and (< stangl (/ pi 2)) (< endang (/ pi 2)))
                   (and (> stangl (/ pi 2)) (> endang (/ pi 2))))
               (setq ymax (+ (cadr cen) rad))
               (setq ymax (max (cadr cwend) (cadr ccwend))))
           (if (or (and (< stangl (* pi 1.5)) (< endang (* pi 1.5)))
                   (and (> stangl (* pi 1.5)) (> endang (* pi 1.5))))
               (setq ymin (- (cadr cen) rad))
               (setq ymin (min (cadr cwend) (cadr ccwend))))))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Arb end.                                                              
 ; 

 ; Ŀ
 ;   Bada - box the attributes attached to a block.                        
 ;   Copyright 2001 by Rocket Software                                     
 ;   Takes one argument, a block ename.                                    
 ;   Returns a list of corner points (typically 4.)                        
 ; 
 (DEFUN BADA (enam xmax xmin ymax ymin / typ mxlst)
  (while (/= "SEQEND" (setq typ (cdr (assoc 0 (entget
                                               (setq enam (entnext enam)))))))
         (if (and (= typ "ATTRIB")
                  (setq mxlst (tb enam)))
             (progn
                  (if xmax
                      (setq xmax (max xmax (car mxlst)))
                      (setq xmax (car mxlst)))
                  (if xmin
                      (setq xmin (min xmin (cadr mxlst)))
                      (setq xmin (cadr mxlst)))
                  (if ymax
                      (setq ymax (max ymax (caddr mxlst)))
                      (setq ymax (caddr mxlst)))
                  (if ymin
                      (setq ymin (min ymin (cadddr mxlst)))
                      (setq ymin (cadddr mxlst))))))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Bada end.                                                             
 ; 

 ; Ŀ
 ;   Bent test.                                                            
 ; 
 (DEFUN C:BENT (/ enam)
  (setq enam (car (entsel "Block: ")))
  (print (bent (cdr (assoc 2 (entget enam)))))
 (princ))

 ; Ŀ
 ;   Subroutine Bent - find the outer corners of a block definition.       
 ;   Argument: Blnam, the block name.                                      
 ;   Returns a list of the block insertion point and the four corners.     
 ; 
 (DEFUN BENT (blnam / blok blintz namm entt typ mxlst xmax xmin ymax ymin)
 ; Ŀ
 ;   Notes: 1. Entnext returns nil after the last entity in a block        
 ;             definition.                                                 
 ;          2. An empty block has one subentity of type Endblk.            
 ; 
  (setq blok (tblsearch "block" blnam))     ; get head entity
  (setq blintz (cdr (assoc 10 blok)))
  (setq namm (cdr (assoc -2 blok)))         ; first ename after head
  (while namm                               ; while there is an entity
        (setq entt (entget namm))           ; the whole thing
        (setq typ (cdr (assoc 0 entt)))
        (cond ((= typ "POLYLINE")
               (setq mxlst (parc namm)))
              ((= typ "LWPOLYLINE")
               (setq mxlst (lwp namm)))
              ((= typ "ARC")
               (setq mxlst (arb namm)))
              ((= typ "CIRCLE")
               (setq mxlst (cb namm)))
              ((= typ "HATCH")
               (setq mxlst (ahatch namm)))
              ((= typ "INSERT")
               (setq mxlst (p22 namm)))
              ((= typ "TEXT")
               (setq mxlst (tb namm)))
              ((= typ "LINE")
               (setq mxlst (lb namm)))
              ((= typ "SOLID")
               (setq mxlst (sb namm)))
              ((= typ "POINT")
               (setq mxlst (pb namm))))
        (if mxlst
            (progn
                 (if xmax
                     (setq xmax (max xmax (car mxlst)))
                     (setq xmax (car mxlst)))
                 (if xmin
                     (setq xmin (min xmin (cadr mxlst)))
                     (setq xmin (cadr mxlst)))
                 (if ymax
                     (setq ymax (max ymax (caddr mxlst)))
                     (setq ymax (caddr mxlst)))
                 (if ymin
                     (setq ymin (min ymin (cadddr mxlst)))
                     (setq ymin (cadddr mxlst)))))
        (setq namm (entnext namm)))         ; next subentity ename
 ; Ŀ
 ;   And return the entity limits.                                         
 ;   Empty blocks (and probably other entity types) don't have a size,     
 ;   so if any of the maximum and minimum points are nil, return nil       
 ;   to allow the routine to deal with this properly (i.e. ignore it.)     
 ; 
  (if (and xmax xmin ymax ymin)
      (list blintz xmax xmin ymax ymin)))
 ; Ŀ
 ;   Bent end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Bop - draw a temporary box.                                
 ; 
 (DEFUN BOP (mxlst col hilite / xmax xmin ymax ymin)
  (setq xmax (car mxlst))
  (setq xmin (cadr mxlst))
  (setq ymax (caddr mxlst))
  (setq ymin (cadddr mxlst))
  (grdraw (list xmin ymax) (list xmax ymax) col hilite)
  (grdraw (list xmax ymax) (list xmax ymin) col hilite)
  (grdraw (list xmax ymin) (list xmin ymin) col hilite)
  (grdraw (list xmin ymin) (list xmin ymax) col hilite))
 ; Ŀ
 ;   Bop end.                                                              
 ; 

 ; Ŀ
 ;   Subroutine Cb - box a circle.                                         
 ; 
 (DEFUN CB (enam / entt cen rad xmax xmin ymax ymin)
  (setq entt (entget enam))
  (setq cen (cdr (assoc 10 entt)))
  (setq rad (cdr (assoc 40 entt)))
  (setq xmax (+ (car cen) rad))
  (setq xmin (- (car cen) rad))
  (setq ymax (+ (cadr cen) rad))
  (setq ymin (- (cadr cen) rad))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Cb end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine Lb - box a line.                                           
 ; 
 (DEFUN LB (enam / entt ten eleven xmax xmin ymax ymin)
  (setq entt (entget enam))
  (setq ten (cdr (assoc 10 entt)))
  (setq eleven (cdr (assoc 11 entt)))
  (setq xmax (max (car ten) (car eleven)))
  (setq xmin (min (car ten) (car eleven)))
  (setq ymax (max (cadr ten) (cadr eleven)))
  (setq ymin (min (cadr ten) (cadr eleven)))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Lb end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine Lwp - box a lwpolyline.                                    
 ;   Copyright 2001 by Rocket Software Ltd.                                
 ; 
 (DEFUN LWP (enam / entt closed sub subent vertx1 vertx0 bulgep mxlst xmax
                                                 xmin ymax ymin bulge vertx2)
  (setq entt (entget enam))
 ; Ŀ
 ;   See if the polyline is closed.                                        
 ; 
  (if (assoc 70 entt)
      (setq closed (logand 1 (cdr (assoc 70 entt)))))
 ; Ŀ
 ;   Ditch everything up to the first ten group.                           
 ; 
  (while (and (setq sub (car entt))
              (/= (car sub) 10))
         (setq entt (cdr entt)))
 ; Ŀ
 ;   While there are vertices... (In this case ten groups.)                
 ; 
  (while entt
 ; Ŀ
 ;   Make a list of the sublists up to the next ten sublist.               
 ; 
         (setq subent ())
         (while (and (setq sub (car entt))
                     (or (and (not (assoc 10 subent)) (= (car sub) 10))
                         (/= (car sub) 10)))
                (setq entt (cdr entt))
                (setq subent (cons sub subent)))
 ; Ŀ
 ;   Get the next vertex.                                                  
 ; 
         (setq vertx1 (cdr (assoc 10 subent)))
 ; Ŀ
 ;   If the polyline is closed, save the first vertex.                     
 ; 
         (if (and (null vertx0) (= closed 1))
             (setq vertx0 vertx1))
 ; Ŀ
 ;   Get the bulge factor.                                                 
 ; 
         (setq bulgep (cdr (assoc 42 subent)))
 ; Ŀ
 ;   Process the segment according to its vertex data.                     
 ; 
         (cond ((and (null entt) vertx0 bulge (/= bulge 0))
                (setq mxlst (pobble vertx0 vertx2 bulge)))
               ((and (null entt) vertx0)
                (setq mxlst (pl vertx0 vertx2)))
               ((and vertx1 vertx2 bulge (/= bulge 0))
                (setq mxlst (pobble vertx1 vertx2 bulge)))
               ((and vertx1 vertx2)
                (setq mxlst (pl vertx1 vertx2)))
               ((null entt)
                (setq mxlst ())))
 ; Ŀ
 ;   If the subroutine returned a limit list then update limit variables.  
 ; 
         (if mxlst
             (progn
                  (if xmax
                      (setq xmax (max xmax (car mxlst)))
                      (setq xmax (car mxlst)))
                  (if xmin
                      (setq xmin (min xmin (cadr mxlst)))
                      (setq xmin (cadr mxlst)))
                  (if ymax
                      (setq ymax (max ymax (caddr mxlst)))
                      (setq ymax (caddr mxlst)))
                  (if ymin
                      (setq ymin (min ymin (cadddr mxlst)))
                      (setq ymin (cadddr mxlst)))))
         (setq bulge bulgep)
         (setq vertx2 vertx1))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Lwp end.                                                              
 ; 

 ; Ŀ
 ;   Subroutine P22 - box a block.                                         
 ; 
 (DEFUN P22 (enam / entt rota inss bloscx bloscy typp blnam blok blintz namm
                         typ mxlst xmax xmin ymax ymin xins yins ll ul ur lr)
  (setq entt (entget enam))
 ; Ŀ
 ;   Notes: 1. Entnext returns nil after the last entity in a block        
 ;             definition.                                                 
 ;          2. An empty block has one subentity of type Endblk.            
 ; 
  (if (and entt
           (setq rota (cdr (assoc 50 entt)))
           (setq inss (cdr (assoc 10 entt)))
           (setq bloscx (cdr (assoc 41 entt)))
           (setq bloscy (cdr (assoc 42 entt)))
           (setq inss (cdr (assoc 10 entt)))
           (setq typp (cdr (assoc 0 entt)))
           (or (= typp "INSERT")
               (= typp "DIMENSION"))
           (setq blnam (cdr (assoc 2 entt)))
           (setq blok (tblsearch "block" blnam)))    ; get head entity
      (progn
           (setq blintz (cdr (assoc 10 blok)))
           (setq namm (cdr (assoc -2 blok)))         ; first ename after head
           (while namm                               ; while there is an entity
                 (setq entt (entget namm))           ; the whole thing
                 (setq typ (cdr (assoc 0 entt)))
                 (cond ((= typ "POLYLINE")
                        (setq mxlst (parc namm)))
                       ((= typ "LWPOLYLINE")
                        (setq mxlst (lwp namm)))
                       ((= typ "ARC")
                        (setq mxlst (arb namm)))
                       ((= typ "CIRCLE")
                        (setq mxlst (cb namm)))
                       ((= typ "HATCH")
                        (setq mxlst (ahatch namm)))
                       ((= typ "INSERT")
                        (setq mxlst (p22 namm)))
                       ((= typ "TEXT")
                        (setq mxlst (tb namm)))
                       ((= typ "LINE")
                        (setq mxlst (lb namm)))
                       ((= typ "SOLID")
                        (setq mxlst (sb namm)))
                       ((= typ "POINT")
                        (setq mxlst (pb namm))))
                 (if mxlst
                     (progn
                          (if (and xmax (car mxlst))
                              (setq xmax (max xmax (car mxlst)))
                              (setq xmax (car mxlst)))
                          (if (and xmin (cadr mxlst))
                              (setq xmin (min xmin (cadr mxlst)))
                              (setq xmin (cadr mxlst)))
                          (if (and ymax (caddr mxlst))
                              (setq ymax (max ymax (caddr mxlst)))
                              (setq ymax (caddr mxlst)))
                          (if (and ymin (cadddr mxlst))
                              (setq ymin (min ymin (cadddr mxlst)))
                              (setq ymin (cadddr mxlst)))))
                 (setq namm (entnext namm)))))         ; next subentity ename
  (if (and xmax xmin ymax ymin)
      (progn
 ; Ŀ
 ;   Adjust coordinates for block scale and for offset of insertion point  
 ;   from 0,0.                                                             
 ; 
           (setq xins (car inss))
           (setq yins (cadr inss))
           (setq xmax (+ xins (* bloscx (- xmax (car blintz)))))
           (setq xmin (+ xins (* bloscx (- xmin (car blintz)))))
           (setq ymax (+ yins (* bloscy (- ymax (cadr blintz)))))
           (setq ymin (+ yins (* bloscy (- ymin (cadr blintz)))))
 ; Ŀ
 ;   And adjust coordinates for block rotation.                            
 ;   Note: need to adjust block subentity limits for rotation - this is    
 ;   too inexact.                                                          
 ; 
           (setq ll (list xmin ymin))
           (setq ll (polar inss (+ (angle inss ll) rota)
                                  (distance inss ll)))
           (setq ul (list xmin ymax))
           (setq ul (polar inss (+ (angle inss ul) rota)
                                  (distance inss ul)))
           (setq ur (list xmax ymax))
           (setq ur (polar inss (+ (angle inss ur) rota)
                                  (distance inss ur)))
           (setq lr (list xmax ymin))
           (setq lr (polar inss (+ (angle inss lr) rota)
                                  (distance inss lr)))
           (setq xmax (max (car ll) (car lr) (car ul) (car ur)))
           (setq xmin (min (car ll) (car lr) (car ul) (car ur)))
           (setq ymax (max (cadr ll) (cadr lr) (cadr ul) (cadr ur)))
           (setq ymin (min (cadr ll) (cadr lr) (cadr ul) (cadr ur)))))
 ; Ŀ
 ;   And return the entity limits.                                         
 ;   Empty blocks (and probably other entity types) don't have a size,     
 ;   so if any of the maximum and minimum points are nil, return nil       
 ;   to allow the routine to deal with this properly (i.e. ignore it.)     
 ; 
  (if (and xmax xmin ymax ymin)
      (list xmax xmin ymax ymin)))
 ; Ŀ
 ;   P22 end.                                                              
 ; 

 ; Ŀ
 ;   Subroutine Pb - box a point.                                          
 ; 
 (DEFUN PB (enam / entt ten xmax xmin ymax ymin)
  (setq entt (entget enam))
  (setq ten (assoc 10 entt))
  (setq xmax (setq xmin (cadr ten)))
  (setq ymax (setq ymin (caddr ten)))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Pb end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine Sb - box a solid.                                          
 ; 
 (DEFUN SB (enam / entt ten eleven twelve thirt xmax xmin ymax ymin)
  (setq entt (entget enam))
  (setq ten (cdr (assoc 10 entt)))
  (setq eleven (cdr (assoc 11 entt)))
  (setq twelve (cdr (assoc 12 entt)))
  (setq thirt (cdr (assoc 13 entt)))
  (setq xmax (max (car ten) (car eleven) (car twelve) (car thirt)))
  (setq xmin (min (car ten) (car eleven) (car twelve) (car thirt)))
  (setq ymax (max (cadr ten) (cadr eleven) (cadr twelve) (cadr thirt)))
  (setq ymin (min (cadr ten) (cadr eleven) (cadr twelve) (cadr thirt)))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Sb end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine Tb - text boxer.                                           
 ; 
 (DEFUN TB (enam / entt bb rota cc dd bheigt bwidth llangg lldist ll ul lr ur
                                                      xmax xmin ymax ymin str)
  (setq entt (entget enam))
  (setq bb (textbox entt))
  (setq rota (cdr (assoc 50 entt)))
  (setq cc (car bb))
  (setq dd (cadr bb))
  (setq bheigt (- (cadr dd) (cadr cc)))
  (setq bwidth (- (car dd) (car cc)))
  (setq llangg (angle (list 0 0) cc))
  (setq lldist (distance (list 0 0) cc))
  (setq ll (polar (cdr (assoc 10 entt)) (+ llangg rota) lldist))
  (setq ul (polar ll (+ rota (/ pi 2)) bheigt))
  (setq lr (polar ll rota bwidth))
  (setq ur (polar lr (+ rota (/ pi 2)) bheigt))
 ; Ŀ
 ;   Now have the real upper left, upper right, etc. points of the text.   
 ; 
  (setq xmax (max (car ul) (car ll) (car ur) (car lr)))
  (setq xmin (min (car ul) (car ll) (car ur) (car lr)))
  (setq ymax (max (cadr ul) (cadr ll) (cadr ur) (cadr lr)))
  (setq ymin (min (cadr ul) (cadr ll) (cadr ur) (cadr lr)))
 ; Ŀ
 ;   Having gone through all of that, if the text string is either empty   
 ;   or contains nothing but spaces, it shouldn't affect the percieved     
 ;   size of the block, so return nil.  (I think that the main function    
 ;   can handle this...)                                                   
 ; 
  (setq typ (cdr (assoc 0 entt)))
  (cond ((or (= typ "ATTRIB") (= typ "TEXT"))
         (setq str (cdr (assoc 1 entt))))
        ((= typ "ATTDEF")
         (setq str (cdr (assoc 2 entt)))))
  (while (= (substr str 1 1) " ") (setq str (substr str 2)))
 (if (= str "") nil (list xmax xmin ymax ymin)))
 ; Ŀ
 ;   Tb end.                                                               
 ; 

 ; Ŀ
 ;   Parc - polyline boxer & subroutines.                                  
 ; 

 ; Ŀ
 ;   Subroutine Pobble - box a bulged section in a polyline.               
 ;   Calls P3 to find the centre and radius of the bulge and               
 ;   Ab to calculate the box extents.                                      
 ; 
 (DEFUN POBBLE (vertx1 vertx2 bulge / angg dist hapf top crlist rad cen
                                                          stangl endang mxlst)
 ; Ŀ
 ;   The next section is a fix for crashing on the two points being        
 ;   identical.                                                            
 ; 
  (if (equal vertx1 vertx2)
      (setq mxlst (list (car vertx1) (car vertx1)
                        (cadr vertx1) (cadr vertx1)))
      (progn
           (setq angg (angle vertx1 vertx2))
           (setq dist (/ (distance vertx1 vertx2) 2))
           (setq hapf (polar vertx1 angg dist))
           (setq top (polar hapf (+ angg (/ pi 2)) (* dist bulge)))
           (setq crlist (3p vertx1 vertx2 top))
           (setq rad (cadr crlist))
           (setq cen (car crlist))
           (if (minusp bulge)
               (progn
                    (setq stangl (angle cen vertx1))
                    (setq endang (angle cen vertx2)))
               (progn
                    (setq stangl (angle cen vertx2))
                    (setq endang (angle cen vertx1))))
           (setq mxlst (ab cen rad stangl endang))))
 mxlst)
 ; Ŀ
 ;   Pobble end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Pl - box a straight polyline segment.                      
 ; 
 (DEFUN PL (ten eleven / xmax xmin ymax ymin)
  (setq xmax (max (car ten) (car eleven)))
  (setq xmin (min (car ten) (car eleven)))
  (setq ymax (max (cadr ten) (cadr eleven)))
  (setq ymin (min (cadr ten) (cadr eleven)))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Pl end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine 3p - returns the centre and radius of a circle which       
 ;   intersects three points.                                              
 ; 
 (DEFUN 3P (p1 p2 p3 / ang12 dist12 pmid12 ang23 dist23 pmid23 mid123 radd)
  (setq ang12 (angle p1 p2))
  (setq dist12 (distance p1 p2))
  (setq pmid12 (polar p1 ang12 (/ dist12 2)))
  (setq ang23 (angle p2 p3))
  (setq dist23 (distance p2 p3))
  (setq pmid23 (polar p2 ang23 (/ dist23 2)))
  (if (setq mid123 (inters pmid12 (polar pmid12 (+ ang12 (/ pi 2)) 10)
                           pmid23 (polar pmid23 (+ ang23 (/ pi 2)) 10) nil))
      (setq radd (distance p1 mid123)))
 (list mid123 radd))
 ; Ŀ
 ;   3p end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine Ab - box an arc.                                           
 ;   Takes four arguments: the centre point, radius, start angle and end   
 ;   angle.                                                                
 ; 
 (DEFUN AB (cen rad stangl endang / cwend ccwend xmax xmin ymax ymin)
  (setq cwend (polar cen stangl rad))
  (setq ccwend (polar cen endang rad))
 ; Ŀ
 ;   See if the arc crosses its (y=0, x>=0) axis.                          
 ; 
  (if (< stangl endang)
      (progn
           (setq xmax (max (car cwend) (car ccwend)))
 ; Ŀ
 ;   Decide which of the other quadrants are on the arc and thus deduce    
 ;   the max and min x and y points.                                       
 ; 
           (if (and (< stangl pi) (> endang pi))
               (setq xmin (- (car cen) rad))
               (setq xmin (min (car cwend) (car ccwend))))
           (if (and (< stangl (/ pi 2)) (> endang (/ pi 2)))
               (setq ymax (+ (cadr cen) rad))
               (setq ymax (max (cadr cwend) (cadr ccwend))))
           (if (and (< stangl (* pi 1.5)) (> endang (* pi 1.5)))
               (setq ymin (- (cadr cen) rad))
               (setq ymin (min (cadr cwend) (cadr ccwend)))))
      (progn
           (setq xmax (+ (car cen) rad))
 ; Ŀ
 ;   Decide which of the other quadrants are on the arc and thus deduce    
 ;   the max and min x and y points.                                       
 ; 
           (if (or (and (> stangl pi) (> endang pi))
                   (and (< stangl pi) (< endang pi)))
               (setq xmin (- (car cen) rad))
               (setq xmin (min (car cwend) (car ccwend))))
           (if (or (and (< stangl (/ pi 2)) (< endang (/ pi 2)))
                   (and (> stangl (/ pi 2)) (> endang (/ pi 2))))
               (setq ymax (+ (cadr cen) rad))
               (setq ymax (max (cadr cwend) (cadr ccwend))))
           (if (or (and (< stangl (* pi 1.5)) (< endang (* pi 1.5)))
                   (and (> stangl (* pi 1.5)) (> endang (* pi 1.5))))
               (setq ymin (- (cadr cen) rad))
               (setq ymin (min (cadr cwend) (cadr ccwend))))))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Ab end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine Parc - box a polyline.                                     
 ; 
 (DEFUN PARC (enam / closed goon typ entt vertx1 vertx0 bulgep mxlst xmax
                                                 xmin ymax ymin bulge vertx2)
 ; Ŀ
 ;   See if the polyline is closed.                                        
 ; 
  (setq closed (logand 1 (cdr (assoc 70 (entget enam)))))
 ; Ŀ
 ;   While there are vertices...                                           
 ; 
  (setq goon T)
  (while goon
         (setq typ (cdr (assoc 0 (setq entt (entget (setq enam
                                                          (entnext enam)))))))
         (setq vertx1 (cdr (assoc 10 entt)))
 ; Ŀ
 ;   If the polyline is closed, save the first vertex.                     
 ; 
         (if (and (null vertx0) (= closed 1))
             (setq vertx0 vertx1))
 ; Ŀ
 ;   Get the bulge factor.                                                 
 ; 
         (setq bulgep (cdr (assoc 42 entt)))
 ; Ŀ
 ;   Process segment according to vertex data.                             
 ; 
         (cond ((and (= typ "SEQEND") vertx0 bulge (/= bulge 0))
                (setq mxlst (pobble vertx0 vertx2 bulge))
                (setq goon ()))
               ((and (= typ "SEQEND") vertx0)
                (setq mxlst (pl vertx0 vertx2))
                (setq goon ()))
               ((= typ "SEQEND")
                (setq goon ())
                (setq mxlst ()))
               ((and vertx1 vertx2 bulge (/= bulge 0))
                (setq mxlst (pobble vertx1 vertx2 bulge)))
               ((and vertx1 vertx2)
                (setq mxlst (pl vertx1 vertx2))))
 ; Ŀ
 ;   If the subroutine returned a limit list then update limit variables.  
 ; 
         (if mxlst
             (progn
                  (if xmax
                      (setq xmax (max xmax (car mxlst)))
                      (setq xmax (car mxlst)))
                  (if xmin
                      (setq xmin (min xmin (cadr mxlst)))
                      (setq xmin (cadr mxlst)))
                  (if ymax
                      (setq ymax (max ymax (caddr mxlst)))
                      (setq ymax (caddr mxlst)))
                  (if ymin
                      (setq ymin (min ymin (cadddr mxlst)))
                      (setq ymin (cadddr mxlst)))))
         (setq bulge bulgep)
         (setq vertx2 vertx1))
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Parc & Parc subroutines end.                                          
 ; 

 ; Ŀ
 ;   Pusser - error handler.                                               
 ; 
 (DEFUN PUSSER (shk / pos entt enam sublst vall)
  (setq *error* esav)
  (if (/= shk "Function cancelled") (write-line shk))
 (princ))
 ; Ŀ
 ;   Pusser end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine P1ssy - box an entity.                                     
 ; 
 (DEFUN P1SSY (enam / typ mxlst xmax xmin ymax ymin)
  (setq typ (cdr (assoc 0 (entget enam))))
  (cond ((= typ "POLYLINE")
         (setq mxlst (parc enam)))
        ((= typ "LWPOLYLINE")
         (setq mxlst (lwp enam)))
        ((= typ "ARC")
         (setq mxlst (arb enam)))
        ((= typ "CIRCLE")
         (setq mxlst (cb enam)))
        ((= typ "HATCH")
         (setq mxlst (ahatch enam)))
        ((= typ "INSERT")
         (setq mxlst (p22 enam))
         (if (= (cdr (assoc 66 (entget enam))) 1)
             (setq mxlst (bada enam (car mxlst) (cadr mxlst)
                                    (caddr mxlst) (cadddr mxlst)))))
        ((or (= typ "TEXT") (= typ "ATTDEF"))
         (setq mxlst (tb enam)))
        ((= typ "LINE")
         (setq mxlst (lb enam)))
        ((= typ "SOLID")
         (setq mxlst (sb enam)))
        ((= typ "POINT")
         (setq mxlst (pb enam))))
  (if mxlst
      (progn
           (bop mxlst 2 1)
           (setq xmax (car mxlst))
           (setq xmin (cadr mxlst))
           (setq ymax (caddr mxlst))
           (setq ymin (cadddr mxlst))))
 (tralis (list xmax xmin ymax ymin)))
 ; Ŀ
 ;   Subroutine P1ssy end.                                                 
 ; 

 ; Ŀ
 ;   Subroutine Pussy - box an ss.                                         
 ; 
 (DEFUN PUSSY (ss / num enam typ mxlst xmax xmin ymax ymin)
  (setq num 0)
  (while (setq enam (ssname ss num))
         (setq num (1+ num))
         (setq typ (cdr (assoc 0 (entget enam))))
         (cond ((= typ "POLYLINE")
                (setq mxlst (parc enam)))
               ((= typ "LWPOLYLINE")
                (setq mxlst (lwp enam)))
               ((= typ "ARC")
                (setq mxlst (arb enam)))
               ((= typ "CIRCLE")
                (setq mxlst (cb enam)))
               ((= typ "HATCH")
                (setq mxlst (ahatch enam)))
               ((= typ "INSERT")
                (setq mxlst (p22 enam))
                (if (= (cdr (assoc 66 (entget enam))) 1)
                    (setq mxlst (bada enam (car mxlst) (cadr mxlst)
                                           (caddr mxlst) (cadddr mxlst)))))
               ((or (= typ "TEXT") (= typ "ATTDEF"))
                (setq mxlst (tb enam)))
               ((= typ "LINE")
                (setq mxlst (lb enam)))
               ((= typ "SOLID")
                (setq mxlst (sb enam)))
               ((= typ "POINT")
                (setq mxlst (pb enam))))
         (if mxlst
             (progn
                  (bop mxlst 2 1)
                  (if xmax
                      (setq xmax (max xmax (car mxlst)))
                      (setq xmax (car mxlst)))
                  (if xmin
                      (setq xmin (min xmin (cadr mxlst)))
                      (setq xmin (cadr mxlst)))
                  (if ymax
                      (setq ymax (max ymax (caddr mxlst)))
                      (setq ymax (caddr mxlst)))
                  (if ymin
                      (setq ymin (min ymin (cadddr mxlst)))
                      (setq ymin (cadddr mxlst))))))
  (tralis (list xmax xmin ymax ymin)))
 ; Ŀ
 ;   Subroutine Pussy end.                                                 
 ; 

 ; Ŀ
 ;   Subroutine Puss: externally called by Hoss: box a block.              
 ;   Takes one argument, an ename.  Returns a list of points.              
 ; 
 (DEFUN PUSS (enam / mxlst)
  (setq mxlst (p22 enam))
  (if (= (cdr (assoc 66 (entget enam))) 1)
      (setq mxlst (bada enam (car mxlst) (cadr mxlst)
                             (caddr mxlst) (cadddr mxlst))))
 mxlst)
 ; Ŀ
 ;   Subroutine Puss end.                                                  
 ; 

 ; Ŀ
 ;   Tralis - translate the list of x and y values returned by pussy.      
 ; 
 (DEFUN TRALIS (mxlst)
  (list (car (trans (list (car mxlst) 0 0) 0 1))
        (car (trans (list (cadr mxlst) 0 0) 0 1))
        (cadr (trans (list 0 (caddr mxlst) 0) 0 1))
        (cadr (trans (list 0 (cadddr mxlst) 0) 0 1))))
 ; Ŀ
 ;   Tralis end.                                                           
 ; 

 ; Ŀ
 ;   Pt - a test program.                                                  
 ; 
 (DEFUN C:PT () (bop (puss (car (entsel "Block: "))) 1 0) (princ))

 ; Ŀ
 ;   Pussy.                                                                
 ; 
 (DEFUN C:PUSSY (/ esav ss mxlst)
  (setq esav *error*)                    ; save the previous error handler
  (setq *error* pusser)                  ; and install the new one
  (setq ss (ssget))
  (setq mxlst (pussy ss))
  (setq mxlst (tralis mxlst))
  (bop mxlst 1 0)
  (setq *error* esav)                    ; restore the original error handler
 (princ))

(princ)
