 ; Ŀ
 ;   Sta - star maker                                                      
 ;   Copyright 1993, 1997, 2014 by Rocket Software Ltf.                    
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Sta - draw an individual grstar                            
 ;   Takes four arguments: top, side length, rotation (radians),           
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN STA (pa sidlen rota colo / anginc angg hafang pb)
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota (* 1.6 pi)))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Sta end.                                                   
 ; 

 ; Ŀ
 ;   Subroutine Cta.                                                       
 ; 
 (DEFUN CTA (pa perc / vsize angg rad pa2)
  (setq vsize (getvar "viewsize"))
  (setq rad (* perc vsize 0.5))
  (setq angg 0)
  (repeat 18
         (setq pa2 (polar pa angg rad))
         (sta pa2 (* perc vsize 0.045) (- angg (/ pi 2)) 1)
         (setq angg (+ angg (/ pi 9))))
 (princ))
 ; Ŀ
 ;   Subroutine Cta end.                                                   
 ; 

 ; Ŀ
 ;   Sta.                                                                  
 ; 
 (DEFUN C:STA (/ blip pa perc vsize angg rad pa2)
  (setq blip (getvar "blipmode"))
  (setvar "blipmode" 0)
  (if (null (setq pa (getpoint "Centre <Centre>: ")))
      (setq pa (getvar "viewctr")))
  (if (setq perc (getreal "Percentage of screen height <25>: "))
      (setq perc (* 0.01 perc))
      (setq perc 0.25))
  (cta pa perc)
  (setvar "blipmode" blip)
 (princ))