 ; Ŀ
 ;   Str - yet another pattern drawer.                                     
 ;   Copyright 1993, 2014 by Rocket Software Ltd.                          
 ;   Why it is still not possible to purchase snakeskin textured floppies? 
 ; 

 ; Ŀ
 ;   Conx.                                                                 
 ; 
 (DEFUN CONX (plist cycles / num pa aa)
  (if (null cycles) (setq cycles (length plist)))
  (setq plist (append (list ()) plist))
  (repeat cycles
         (setq plist (cdr plist))
         (setq num 1)
         (setq pa (car plist))
         (while (setq aa (nth num plist))
                (command "line" pa aa "")
                (setq num (1+ num))))
 (princ))
 ; Ŀ
 ;   Conx.                                                                 
 ; 

 ; Ŀ
 ;   Numsuf.                                                               
 ; 
 (DEFUN NUMSUF (num / sufs suff)
  (if (member (type num) '(int real))
      (setq num (rtos num)))
  (setq sufs '(("1" "st") ("2" "nd") ("3" "rd")))
  (if (not (setq suff (cadr (assoc (substr num 1 1) sufs))))
      (setq suff "th"))
 suff)
 ; Ŀ
 ;   Numsuf.                                                               
 ; 

 ; Ŀ
 ;   Enth - extract every nth sublist from a list.                         
 ;   Arguments: Lista, a list.                                             
 ;              Nx, a number.                                              
 ;   Returns a list.                                                       
 ; 
 (DEFUN ENTH (lista nx / num len gnu)
  (setq num 0)
  (setq len (length lista))
  (while (>= len num)
         (if (or (zerop num)
                 (zerop (rem num nx)))
             (setq gnu (cons (nth num lista) gnu)))
         (setq num (1+ num)))
 gnu)
 ; Ŀ
 ;   Enth.                                                                 
 ; 

 ; Ŀ
 ;   Pliz: get a list of lwpline or pline vertex points.                   
 ; 
 (DEFUN PLIZ (enam / typ entt enam pa seglst num sub)
  (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
 ; Ŀ
 ;   Polyline.                                                             
 ; 
  (cond ((= typ "POLYLINE")
         (while (/= "SEQEND" (cdr (assoc 0 (setq entt
                                       (entget (setq enam (entnext enam)))))))
                (setq pa (cdr (assoc 10 entt)))
                (setq seglst (cons pa seglst))))
 ; Ŀ
 ;   Lwpolyline.                                                           
 ; 
        ((= typ "LWPOLYLINE")
         (setq num 0)
         (while (setq sub (nth num entt))
                (setq num (1+ num))
                (if (= (car sub) 10)
                    (progn
                         (setq pa (cdr sub))
                         (setq seglst (cons pa seglst))))))
 ; Ŀ
 ;   Anything else.                                                        
 ; 
        (T nil))
 seglst)
 ; Ŀ
 ;   Pliz end.                                                             
 ; 



 ; Ŀ
 ;   Str.                                                                  
 ; 
 (DEFUN C:STR (/ circ typ entt pa rad divs ang incang aa plist cycles every
                                                                      skips)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (if (and (setq circ (entsel "Select a circle or <Return> to pick points: "))
           (setq circ (car circ))
           (setq typ (cdr (assoc 0 (setq entt (entget circ))))))
      ())
  (cond ((member typ '("CIRCLE" "ARC"))
         (setq pa (cdr (assoc 10 entt)))
         (setq rad (cdr (assoc 40 entt)))
         (setq divs (getint "\nNumber of points: "))
         (setq ang 0)
         (setq incang (/ (* 2 pi) divs))
         (repeat divs
                (setq aa (polar pa ang rad))
                (setq ang (+ ang incang))
                (setq plist (append plist (list aa))))
         (setq cycles (getint (strcat "Number of cycles <"
                                      (itoa (length plist)) ">: "))))
        ((member typ '("POLYLINE" "LWPLINE"))
         (setq plist (pliz circ))
         (setq every (/ (length plist) 20))
         (if (zerop every) (setq every 1))
         (if (not (setq skips (getint (strcat "\nUse Every <"
                                               (itoa every)
                                               (numsuf every)
                                              "> Vertex: "))))
             (setq skips every))
         (if (/= skips 1)
             (setq plist (enth plist skips))))
        (t
         (write-line "\nSelect points: ")
         (while (setq aa (getpoint))
                (setq plist (append plist (list aa))))
         (setq cycles (getint (strcat "Number of cycles <"
                                      (itoa (length plist)) ">: ")))))
  (conx plist cycles)
  (command "undo" "end")
 (princ))