 ; Ŀ
 ;   SZ - text/dimension text/attribute width squeezer.                    
 ;   Copyright 1994, 2005, 2006, 2008 by Rocket Software Ltd.              
 ;   Also contains Sz1, set attribute and text widths to 1.                
 ;   Software that works, for people who'd rather not...                   
 ; 

 ; Ŀ
 ;   Sz1 - set all attribute widths in selected blocks, text, etc. to 1.   
 ; 
 (DEFUN C:SZ1 (/ swid num ss enam esav entt)
  (setq swid 1)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq num 0)
  (prompt "Select text/blocks to rewidth: ")
  (if (setq ss (ssget '((-4 . "<or")
                        (0 . "text")
                        (0 . "attdef") 
                        (-4 . "<and") (0 . "INSERT") (66 . 1) (-4 . "and>")
                       (-4 . "or>"))))
      (while (setq enam (ssname ss num))
             (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
             (cond ((= typ "INSERT")
                    (setq esav enam)
                    (while (/= "SEQEND" (cdr (assoc 0 (setq entt
                                       (entget (setq enam (entnext enam)))))))
                           (entmod (subst (cons 41 swid)
                                          (assoc 41 entt) entt)))
                    (entupd esav))
                   ((member typ '("TEXT" "ATTDEF"))
                    (entmod (subst (cons 41 swid) (assoc 41 entt) entt))))
             (setq num (1+ num))))
  (command "undo" "end")
 (princ))
 ; Ŀ
 ;   Sz1 end.                                                              
 ; 

 ; Ŀ
 ;   Sz.                                                                   
 ; 
 (DEFUN C:SZ (/ *error* snapp nent enam entt typ ifdim tt cc nn)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
  (defun *error* (shk)
   (if snapp (setvar "snapmode" snapp))
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
  (if (setq enam (car (setq nent (nentsel
                                "Select something which looks like text: "))))
      (setq typ (cdr (assoc 0 (setq entt (entget enam))))))
  (setvar "snapmode" snapp)
  (if (or (= "TEXT" typ) (= "ATTDEF" typ) (= "ATTRIB" typ))
      (progn
           (setq ifdim (caar (reverse nent)))
           (setq width (cdr (assoc 41 entt)))
           (if (< width 0.5)
               (setq nuwdth 1.0)
               (setq nuwdth (- width 0.05)))
           (entmod (subst (cons 41 nuwdth) (cons 41 width) entt))
           (write-line (strcat "\nOld width: " (rtos width 2 2)
                               "  New width: " (rtos nuwdth 2 2)))
           (if (or (and (= typ "ATTDEF")
                        (= (type ifdim) 'ENAME))
                   (and (= (type ifdim) 'ENAME)
                        (= (cdr (assoc 0 (entget ifdim))) "DIMENSION")))
               (entupd (cdr (assoc -1 (entget ifdim))))
               (entupd enam)))
      (if enam (write-line "\nWrong entity type.")))
   (command "undo" "end")
 (princ))
