 ; Ŀ
 ;   Xf - toggle xclip frames and wipeout frames on/off in synch.          
 ;   Xup - update all xrefs.                                               
 ;   Copyright 2006 - 2013 by Rocket Software Ltd.                         
 ;   An idea: try to understand the problem before suggesting a solution.  
 ; 

 ; Ŀ
 ;   Xf.                                                                   
 ; 
 (DEFUN C:XF ()
  (cond ((= (getvar "xclipframe") 0)
         (setvar "xclipframe" 1)
         (setvar "oleframe" 1)
         (command "imageframe" 1)
         (command "wipeout" "f" "on")
         (prompt "\nFrames On"))
        (t
         (setvar "xclipframe" 0)
         (setvar "oleframe" 0)
         (command "imageframe" 0)
         (command "wipeout" "f" "off")
         (prompt "\nFrames Off.")))
 (princ))

 ; Ŀ
 ;   Xup - update all xrefs.                                               
 ;   Warning: doesn't mention ones it couldn't update.                     
 ; 
 (DEFUN C:XUP (/ rew bldat blnam)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq blnam (cdr (assoc 2 bldat)))
         (setq nampth (cdr (assoc 1 bldat)))
         (setq isxr (= 4 (logand 4 (cdr (assoc 70 bldat)))))
         (cond ((and isxr (findfile nampth))
                (prompt (strcat "\nUpdating " blnam "\n"))
                (command "xref" "r" blnam))
               (isxr
                (prompt (strcat "\nXref File " blnam " Is Missing.\n")))))
  (command "dimregen")
 (princ))

(princ)

