 ; Ŀ
 ;   Zz - Lisp load from text.                                             
 ;   Copyright 1994, 2014 by Rocket Software Ltd.                          
 ;   You can always take automation one more step.                         
 ;   Until it replaces you.                                                
 ; 

 ; Ŀ
 ;   Texu - perhaps replace a string in a textlike entity.                 
 ;   Arguments: Entt, an entity data list.                                 
 ;              Stra, a new string or nil if no change is required.        
 ;   Calls nothing.                                                        
 ;   Returns the original string.                                          
 ;   Builds an antiaircraft cannon out of chocolate chip cookies.          
 ; 
 (DEFUN TEXU (entt stra / num sub ook strb gnu)
  (if (member '(101 . "Embedded Object") entt)
      (progn
           (setq num 0)
           (while (setq sub (nth num entt))
                  (setq num (1+ num))
                  (cond ((equal sub '(101 . "Embedded Object"))
                         (setq ook t))
                        ((and stra ook (= (car sub) 1))
                         (setq strb (cdr sub))
                         (setq sub (cons 1 stra)))
                        ((and ook (= (car sub) 1))
                         (setq strb (cdr sub))))
                  (setq gnu (append gnu (list sub))))
           (if stra (entmod gnu)))
      (progn
           (setq strb (cdr (assoc 1 entt)))
           (if stra (entmod (subst (cons 1 stra) (assoc 1 entt) entt)))))
 strb)
 ; Ŀ
 ;   Texu end.                                                             
 ; 

 ; Ŀ
 ;   Zz.                                                                   
 ; 
 (DEFUN C:ZZ (/ enam ff fn)
  (setq enam (car (nentsel "Lisp Name Text: ")))
  (setq ff (texu (entget enam) nil))
 ; Ŀ
 ;   Load the routine.                                                     
 ; 
  (setq fn (load ff ()))
 ; Ŀ
 ;   Now see if the lisp is defined, run it if so.                         
 ; 
  (if fn
     (progn
          (write-line "\n")
          (eval (read (strcat "(C:" ff ")"))))
     (write-line (strcat "\n*** Unable to load " ff " ***")))
 (princ))