 ; Ŀ
 ;   Atcol - put attributes in listed blocks on the Text1 layer, colour    
 ;   bylayer.                                                              
 ;   Copyright 2009 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Frinze - relayer attributes in block insertions.           
 ; 
 (DEFUN FRINZE (blnam lay / ss len num enam entt asoc8 gnul)
  (if (setq ss (ssget "X" (list (cons 0 "INSERT") (cons 2 blnam) (cons 66 1))))
      (progn
           (setq len (strcat "/" (itoa (sslength ss))))
           (setq num 0)           
           (while (setq enam (ssname ss num))
                  (setq esav enam)
                  (grtext -2 (strcat (itoa (setq num (1+ num))) len))
                  (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget (setq
                                                     enam (entnext enam)))))))
                         (if (setq cola (assoc 62 entt))
                             (setq entt (subst (cons 62 256) cola entt)))
                         (setq asoc8 (assoc 8 entt))
                         (setq gnul (cons 8 lay))
                         (entmod (subst gnul asoc8 entt)))
                  (entupd esav))))
 (princ))
 ; Ŀ
 ;   Frinze end.                                                           
 ; 

 ; Ŀ
 ;   Atcol.                                                                
 ; 
 (DEFUN C:ATCOL (/ *error*)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
  (defun *error* (shk /)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (write-line shk))
  (princ))
 ; Ŀ
 ;   Do it.                                                                
 ; 
  (frinze "hwiretag" "text1")
  (frinze "hwiretagr" "text1")
  (frinze "TOP - RIGHT WIRE TAG" "text1")
  (frinze "vwiretag" "text1")
  (*error* nil)
 (princ))
