 ; Ŀ
 ;   Eye - mark a point.                                                   
 ;   Arguments: Pa, a point.                                               
 ;              Rad, an outer radius.                                      
 ;              Reps, the number of vortex lines.  (25 seems good.)        
 ;              Colo, a colour.                                            
 ; 
 (DEFUN EYE (pa rad reps colo / rad2 angg incr ang2)
  (setq rad2 (/ rad 2))
  (setq angg 0)
  (setq anng 0)
  (setq incr (/ pi (/ reps 2)))
  (repeat reps
          (setq ang2 (+ angg (/ pi (/ reps 5))))
          (setq pax (polar pa angg rad2))  ; inner point
          (setq pbx (polar pa ang2 rad))   ; outer point
          (grdraw pax pbx colo)
          (setq angg (+ angg incr))
          (setq ang3 (- anng (/ pi (/ reps 5))))
          (setq pcx (polar pbx ang3 rad))   ; outer point
          (grdraw pcx pbx 8)
          (setq anng (- anng incr)))
 (princ))
 ; Ŀ
 ;   Vortxx end.                                                           
 ; 

 (defun c:eye ()
  (setq rad (/ (getvar "viewsize") 25))
  (setq pa (getpoint))
  (eye pa rad 36 3)
 (princ))