 ; Ŀ
 ;   Ht - Text Height Change for text, fixed height text and attdefs.      
 ;   Htx - also does attributes in selected blocks.  All of them.          
 ;   Copyright 1990, 2001, 2006, 2012 by Rocket Software Ltd.              
 ;   Standards - an elusive, baffling concept with so many enemies.        
 ; 

 ; Ŀ
 ;   Htx.                                                                  
 ; 
 (defun C:HTX (/ snapp *error* num ss nuhtp enam typ entt esav)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
  (defun *error* (shk)
   (if snapp (setvar "snapmode" snapp))
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
  (setq num 0)
  (prompt "Select text/blocks to rewidth: ")
  (if (setq ss (ssget '((-4 . "<or")
                        (0 . "text")
                        (0 . "attdef") 
                        (0 . "mtext")
                        (-4 . "<and") (0 . "INSERT") (66 . 1) (-4 . "and>")
                       (-4 . "or>"))))
      (progn
           (if (null nuht) (setq nuht 2.5))
           (setq nuhtp (getreal (strcat "New Text Height <"
                                        (rtos nuht 2 2) ">: ")))
           (if nuhtp (setq nuht nuhtp))
           (while (setq enam (ssname ss num))
                  (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
                  (cond ((= typ "INSERT")
                         (setq esav enam)
                         (while (/= "SEQEND" (cdr (assoc 0 (setq entt
                                       (entget (setq enam (entnext enam)))))))
                                (entmod (subst (cons 40 nuht)
                                               (assoc 40 entt) entt)))
                         (entupd esav))
                        ((member typ '("TEXT" "ATTDEF" "MTEXT"))
                         (entmod (subst (cons 40 nuht) (assoc 40 entt) entt))))
                  (setq num (1+ num)))))
  (setvar "snapmode" snapp)
  (command "undo" "end")
 (princ))

 ; Ŀ
 ;   Ht.                                                                   
 ; 
 (defun C:HT ( / ss cc nn num lll lln zz tt)
  (setvar "cmdecho" 0)
  (prompt "Select text to change:")
  (if (setq ss (ssget '((-4 . "<or") (0 . "text") (0 . "mtext") (0 . "attdef")
                        (-4 . "or>"))))
      (progn
           (setq tt (strcat "<" (rtos (cdr (assoc 40 (entget (ssname ss 0)))))
                            "> New height or <Return> to select: "))
           (if (null (setq cc (getreal tt)))
               (progn
                    (setq nn (entget (car (entsel "Text of desired height: "))))
                    (setq typ (cdr (assoc 0 nn)))
                    (if (member typ '("TEXT" "ATTDEF" "MTEXT"))
                        (setq cc (cdr (assoc 40 nn))))))
           (setq num 0)
           (while (and cc (setq lll (ssname ss num)))
                  (setq num (1+ num))
                  (setq lln (entget lll))
                  (setq zz (cdr (assoc 40 lln)))
                  (entmod (subst (cons 40 cc) (cons 40 zz) lln)))
           (if (= cc (fix cc))
               (setq cc (itoa (fix cc)))
               (setq cc (rtos cc)))
           (prompt (strcat "\n" (itoa num) " line"
                           (if (= num 1) "" "s")
                           " changed to "
                           cc " unit height."))))
 (princ))
