 ; Ŀ
 ;   Ishu - insert the Issued For pseudo-rubber-stamp block.               
 ;   Copyright 2001, 2012 by Rocket Software Ltd.                          
 ;   Caution: this will only work with the D-Bord-E title block.           
 ;   Later: should now work with any tb.                                   
 ;                                                                         
 ; 
 (DEFUN C:ISHU (/ issfor ss emin emax ds pa none fn)
  (setvar "cmdecho" 1)
  (setq issfor "ISSUED FOR BID")
 ; Ŀ
 ;   Erase any existing insertions.                                        
 ; 
  (if (setq ss (ssget "X" (list (cons 2 "Issued"))))
      (command ".erase" ss ""))
  (command ".zoom" "e")
 ; Ŀ
 ;   Set or make the title layer.                                          
 ; 
  (if (tblsearch "layer" "title")
      (command "layer" "s" "title" "")
      (command "layer" "m" "title" ""))
 ; Ŀ
 ;   Get the drawing extents.                                              
 ; 
  (setq emin (getvar "extmin"))
  (setq emax (getvar "extmax"))
 ; Ŀ
 ;   Deduce the height and scale.                                          
 ;   And other stuff.                                                      
 ; 
  (setq rptx (car emax))
  (setq topy (cadr emax))
  (setq basy (cadr emin))
  (setq hite (- topy basy))
  (setq scal (fix (+ 0.1 (/ hite 550.0))))
  (setq bapt (polar (list rptx basy) 0 (* scal 5)))
 ; Ŀ
 ;   Insert the block.                                                     
 ; 
  (command ".insert" "issued" bapt (* scal 2) "" "90" issfor)
 (princ))