 ; Ŀ
 ;   Noed - remove the educational software stamp from a dxf file.         
 ;   Copyright 1994, 2012, 2014, 2015 by Rocket Software Ltd.              
 ;                                                                         
 ; 
 (DEFUN C:NOED (/ *error* filnam fn fo prefa danam filo stra xdel)
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
  (if fn (close fn))
  (if fo (close fo))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Get a filename.                                                       
 ; 
  (setq filnam (getfiled "Dxf File" "" "dxf" 0))
  (setq prefa (getvar "dwgprefix"))
  (setq danam (vl-filename-base filnam))
  (setq filnam (strcat prefa danam ".dxf"))
  (print (findfile filnam))
 ; Ŀ
 ;   Make a new filename - the same location and extension, changed name.  
 ; 
  (setq filo (strcat prefa danam "_noed.dxf"))
  (print filo)
 ; Ŀ
 ;   Read the file, write certain portions of it to the new one.           
 ; 
  (setq fn (open filnam "r"))
  (setq fo (open filo "w"))
  (while (setq stra (read-line fn))
         (if (= stra "$FINGERPRINTGUID")
             (progn
                  (setq xdel t)
                  (repeat 7 (read-line fn)))
             (write-line stra fo)))
  (close fn)
  (close fo)
 ; Ŀ
 ;   Report back to HQ.                                                    
 ; 
  (if xdel (write-line "\nStamp Removed."))
 (princ))