 ; Ŀ
 ;   Noprox - remove proxy crap from a dxf file.                           
 ;   Copyright 1994, 2012, 2014 by Rocket Software Ltd.                    
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Trist - remove leading and trailing spaces from a string.  
 ;   Argument: Linn, a string.                                             
 ;   Calls nothing, returns a string, possibly modified.                   
 ; 
 (DEFUN TRIST (linn / len)
  (while (and (= (substr linn 1 1) " ")
              (/= (strlen linn) 0))
         (setq linn (substr linn 2)))
  (while (and (/= (strlen linn) 0)
              (= (substr linn (setq len (strlen linn))) " "))
         (setq linn (substr linn 1 (1- len))))
 linn)
 ; Ŀ
 ;   Subroutine Trist end.                                                 
 ; 

 ; Ŀ
 ;   Noprox.                                                               
 ; 
 (DEFUN C:NOPROX (/ *error* filnam fn fo prefa danam filo str stra strb xdel)
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
  (if fn (close fn))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Dxfout the current drawing.                                           
 ; 
  (command "dxfout" "" "")
 ; Ŀ
 ;   Get a filename.                                                       
 ; 
 ; (setq filnam (getfiled "Dxf File" "" "dxf" 0)) ; the old way
  (setq prefa (getvar "dwgprefix"))
  (setq danam (vl-filename-base (getvar "dwgname")))
  (setq filnam (strcat prefa danam ".dxf"))
  (print (findfile filnam))
 ; Ŀ
 ;   Make a new filename - the same location and extension, changed name.  
 ; 
  (setq filo (strcat prefa danam "_noprox.dxf"))
  (print filo)
 ; Ŀ
 ;   Set the Write To File flag Wrat.                                      
 ; 
  (setq wrat t)
 ; Ŀ
 ;   Read the file, write certain portions of it to the new one.           
 ; 
  (setq fn (open filnam "r"))
  (setq fo (open filo "w"))
  (setq xdel 0)
  (while (and (setq stra (read-line fn))
              (setq strb (read-line fn)))
 ; Ŀ
 ;   Need two lines, in order, stra and strb: dxf files are organized      
 ;   in pairs: type_number and value.                                      
 ;   Is this invariable?  Proceed on this assumption...                    
 ; 
         (cond ((and (= (trist stra) "0")
                     (member (trist strb) '("ACAD_PROXY_OBJECT"
                                            "ACAD_PROXY_ENTITY")))
                (setq xdel (1+ xdel))
                (setq wrat nil))
               ((= (trist stra) "0")
                (setq wrat t)))
         (if wrat
             (progn
                  (write-line stra fo)
                  (write-line strb fo))))
  (close fn)
  (close fo)
 ; Ŀ
 ;   Report back to HQ.                                                    
 ; 
  (write-line (strcat "Proxies removed: " (itoa xdel)))
 (princ))