 ; Ŀ
 ;                                                                Ĵ
 ;       Punk - insert multiple blocks, increment tags, eat             
 ;       a live rat while wearing roller skates, etc., etc.            ô 
 ;       Copyright 1994, 2001, 2002, 2010 by Rocket Software Ltd.      ô 
 ;  ÿ     A routine with no goal in life and a bad attitude.             
 ; Ŀ                                                               Ĵ
 ; 
 (DEFUN C:PUNK (/ *error* pa numblp dis tagstr tagp incrp tagg blnam brkdis
                                                                     pb1 pb2)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq osmo (getvar "osmode"))
 ; Ŀ
 ;    Make an error handler.                                             
 ;                                                                       
 ; 
  (defun *error* (shk)
   (setvar "osmode" osmo)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
 ; Ŀ
 ;    First gently extract the requisite information from the            
 ;    semiconscious user.                                                
 ; 
  (if (= "" (setq blnam (getstring t "Block name or <Return> to select: ")))
      (setq blnam (cdr (assoc 2 (entget (car (entsel "Block: ")))))))
  (setq pa (getpoint "\nFirst insertion point: "))
  (if (/= (type numbl) 'INT) (setq numbl 16))
  (setq numblp (getint (strcat "\nNumber of insertions <" (itoa numbl) ">: ")))
  (if numblp (setq numbl numblp))
  (if (/= (type dist) 'REAL) (setq dist 20))
  (setq dis (getdist pa (strcat "\nIntermediary distance <"
                                                       (rtos dist 2 2) ">: ")))
  (if dis (setq dist dis))
  (if (= (type tagsav) 'INT)
      (setq tagstr (strcat "\nInitial terminal block tag <" (itoa tagsav) ">: "))
      (setq tagstr "\nInitial terminal block tag: "))
  (setq tagp (getint tagstr))
  (if tagp (setq tagg tagp)
           (setq tagg tagsav))
  (setq tagsav tagg)         
  (if (/= (type termincr) 'INT) (setq termincr 10))
  (setq incrp (getint (strcat "Increment <" (itoa termincr) ">: ")))
  (if incrp (setq termincr incrp))
 ; Ŀ
 ;    Try to ascertain the line break width from the block name.         
 ;                                                                       
 ; 
  (setq blnam (strcase blnam t))
  (cond ((member (substr blnam 1 6) '("termcr" "termsq"
                                      "termhx" "termdi"))
         (setq brkdis 2.5))
        ((= (substr blnam 1 6) "termtr")
         (setq brkdis 1.25))
        ((member blnam '("2xwiretag" "hwiretag"))
         (setq brkdis 0))
        ((= blnam "fieldterminal")
         (setq brkdis 5))
        (T (setq brkdis (/ (getdist "Break width: ") 2))))
 ; Ŀ
 ;   Insert the block and increment the tag.                          
 ;Ŀ                                                                   
 ; 
  (setvar "osmode" 0)
  (repeat numbl
         (setq pb1 (polar pa pi brkdis))
         (setq pb2 (polar pa 0 brkdis))
         (if (and (/= brkdis 0) (nentselp pb1) (nentselp pb2))
             (command ".break" pb1 pb2))
         (command "insert" blnam pa "" "" "" (itoa tagg))
         (while (= 1 (getvar "cmdactive")) (command " "))
         (setq pa (polar pa (* pi 1.5) dist))
         (setq tagg (+ tagg termincr)))
  (*error* ())
 (princ))
 ; Ŀ
 ;     Message ends.                                                       
 ; 
