   ;  Text CHange - change one or more lines to a single text string.
   ;  Copyright 1990, 2005, 2007 by Rocket Software Ltd.
   ;  Software that works, for people who'd rather not...

 ; Ŀ
 ;   Tatere - extract the string from an entity.                           
 ;   Arguments: Promo, the prompt string.                                  
 ;   Calls nothing.                                                        
 ;   Returns a string or nil.                                              
 ; 
 (DEFUN TATERE (promo / nn cc)
  (if (and (setq nn (nentsel (strcat "\n" promo)))
           (setq cc (assoc 1 (entget (car nn)))))
      (progn
           (setq cc (cdr cc))
           (princ (strcat cc "\n"))))
 cc)
 ; Ŀ
 ;   Tatere end.                                                           
 ; 

 ; Ŀ
 ;   Tch.                                                                  
 ; 
 (defun C:TCH ( / SS CC NUM LLL LLN ZZ TT)
   (setvar "cmdecho" 0)
   (command "undo" "be")
   (setq snapp (getvar "snapmode"))
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
   (defun *error* (shk)
    (if snapp (setvar "snapmode" snapp))
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (princ))
 ; Ŀ
 ;   Turn Snap off.                                                        
 ; 
   (setvar "snapmode" 0)
   (prompt "Please Select Text (you may select several).")
   (setq ss (ssget))                               ; Get text entities
   (if (= "TEXT" (cdr (assoc 0 (entget (ssname SS 0)))))
       (setq tt (strcat "<" (cdr (assoc 1 (entget (ssname ss 0))))
                        "> New text or <Return> to select: "))
       (setq tt "New text or <Return> to select: "))
   (setq cc (getstring t tt))                      ; Get new text string
   (if (= cc "")
       (setq cc (tatere "Select source text: ")))
   (if (and cc (/= cc ""))
       (progn
       (setq num 0)                                ; Start counter
       (while (ssname ss 0)                        ; while there is a #1 
              (setq lll (ssname ss 0))             ; get 1st entity name
              (setq lln (entget lll))              ; get the whole thing
              (if (= "TEXT" (cdr (assoc 0 lln)))   ; Is entity text? (group 0)
                  (progn
                  (setq num (1+ num))              ; increment counter
                  (setq zz (cdr (assoc 1 lln)))    ; get text string
                  (entmod (subst (cons 1 cc) (cons 1 zz) lln)) ; replace
                  ) )                              ; progn end, if end
                  (ssdel lll ss)                   ; remove from sel. set
       ))                                          ; progn, while end
        (progn
              (grtext)
              (write-line "bLOORT. No changes."))) ; progn, if end
   (if (= 1 num)
       (setq ttx " entity ")
       (setq ttx " lines "))
   (if (or (< 1 num) (= num 1))
       (progn
             (setq s (* (getvar "cdate") 10000000.0))
             (setq nnum (fix (* 10 (- s ( fix s)))))
 (setq mlst (list "sucked into oblivion." "disenfranchised by evil government."
 "rescued from the dark realm of oblivion." "reanimated by electrical science."
 "galvanized into a wierd pseudo-existence." "translated into dog. "
 "wildly mutated by radioactive fallout." "liberated by the yak people."
 "hastily disavowed by the party on ideological grounds."
 "lightly brushed with clarified butter."
 "given new life and new meaning."))
             (setq mm (nth nnum mlst))
             (prompt (strcat (ITOA num) ttx mm))))
   (if (= 3 num)
       (prompt "\nTickle my keys again, baby."))
   (if (= 0 num)
       (progn
       (prompt "I'm sorry but that wasn't text.")
       (prompt "\nYou cretin.")))
  (setvar "snapmode" snapp)
  (command "undo" "end")
 (princ))
