 ; Ŀ
 ;   Vis: reset the 1 bit in the 70 group of an attribute to 0 (visible).  
 ;   Siv: make all attributes in selected blocks invisible.                
 ;   Copyright 1993, 2011 by Rocket Software Ltd.                          
 ;   Why would anyone buy an add-on package designed primarily to make     
 ;   life difficult?  Then again, why do people wear ties?                 
 ; 
 (DEFUN C:SIV (/ ss enam entt vis)
  (setvar "cmdecho" 0)                    ; don't echo commands (ie next line)
  (command "undo" "be")                   ; set undo marker
  (write-line "Select blocks: ")
  (setq ss (ssget (list (cons 0 "insert") (cons 66 1))))
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))      ; get the first entity name
         (setq num (1+ num))
         (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget
                                               (setq enam (entnext enam)))))))
                (setq vis (cdr (assoc 70 entt)))   ; get att flags
                (setq vis (logior 1 vis))          ; turn visibility off
                (entmod (subst (cons 70 vis) (assoc 70 entt) entt))))
  (command "undo" "end")
 (princ))

 (DEFUN C:VIS (/ ss enam e1nam entt vis)
  (setvar "cmdecho" 0)                    ; don't echo commands (ie next line)
  (command "undo" "be")                    ; set undo marker
  (grtext 0 (getvar "dwgname"))           ; print drawing name to screen menu
  (write-line "Select blocks: ")
  (setq ss (ssget))                       ; select some entities
  (while (and ss (setq enam (ssname ss 0)))   ; get the first entity name
         (setq e1nam enam)                ; save the entity name
         (setq entt (entget enam))        ; get the whole thing
         (if (and (= (cdr (assoc 0 entt)) "INSERT")  ; if it was a block
                  (= (cdr (assoc 66 entt)) 1))       ; with subentities
             (progn
                 (setq entt (entget (setq enam (entnext enam))))
                 (while (/= "SEQEND" (cdr (assoc 0 entt)))
                        (setq vis (cdr (assoc 70 entt)))   ; get att flags
                        (setq vis (logand 14 vis))         ; turn visibility on
                        (entmod (subst (cons 70 vis) (assoc 70 entt) entt))
                        (setq entt (entget (setq enam (entnext enam)))))
                (entupd enam)))
         (ssdel e1nam ss))                 ; remove it from the ss
  (command "undo" "end")
 (princ))