 ; Ŀ
 ;   Vizi - make all invisible entities visible.                           
 ;   Izi - make selected visible entities invisible.                       
 ;   Copyright 2007, 2011 by Rocket Software Ltd.                          
 ;   Bugs, features, and now this.  But why?                               
 ; 

 ; Ŀ
 ;   Vortex - mark a point passed as the only argument.                    
 ; 
 (DEFUN VORTEX (pa rad colo / reps pa rad2 angg incr)
  (if (= colo 0) (setq colo 4))
  (setq reps 75)
  (setq rad2 (* rad 2))
  (setq angg 0)
  (setq incr (/ pi (/ reps 2)))
  (repeat reps
          (setq ang2 (+ angg (/ pi 5)))
          (grdraw (polar pa angg rad2) (polar pa ang2 rad) colo)
          (setq angg (+ angg incr)))
 (princ))
 ; Ŀ
 ;   Vortex end.                                                           
 ; 

 ; Ŀ
 ;   Izi                                                                   
 ; 
 (defun c:izi (/ ss num enam entt viz)
  (write-line "Select stuff to disappear: ")
  (setq ss (ssget))
  (setq num 0)
  (while (setq enam (ssname ss num))
         (setq num (1+ num))
         (setq entt (entget enam))
         (if (setq viz (assoc 60 entt))
             (entmod (subst (cons 60 1) viz entt))
             (entmod (append entt (list (cons 60 1))))))
 (princ))

 ; Ŀ
 ;   Vizi.                                                                 
 ; 
 (defun c:vizi (/ rad ss num enam entt pa)
  (setq rad (/ (getvar "viewsize") 65))
  (if (setq ss (ssget "x" (list (cons 60 1))))
      (progn
           (print (sslength ss))
           (setq num 0)
           (while (setq enam (ssname ss num))
                  (setq num (1+ num))
                  (setq entt (entget enam))
                  (setq pa (cdr (assoc 10 entt)))
                  (entmod (subst (cons 60 0) (cons 60 1) entt))
                  (vortex pa rad num)))
      (prompt "No invisible entities found."))
 (princ))