 ; Ŀ
 ;   Xxlis: list xrefs, add information.                                   
 ;   Copyright 2012 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Cxlis - Find all xref definitions in the block tables.                
 ;   Takes no arguments.                                                   
 ;   Returns a list of strings: ("Blockname,,Filename" ...)                
 ; 
 (DEFUN CXLIS (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (= 4 (logand 4 sevnt))
             (progn
                  (if (= 32 (logand 32 sevnt))
                      (setq reso ", Resolved")
                      (setq reso ", ** Not Resolved **"))
                  (setq reso (strcat reso " (" (itoa sevnt) "), "))
                  (setq blnam (cdr (assoc 2 bldat)))
                  (if (= 16 (logand 16 sevnt))
                      (setq reso (strcat reso " sub-xref, ")))
                  (if (ssget "x" (list (cons 2 blnam)))
                      (setq reso (strcat reso "inserted, "))
                      (setq reso (strcat reso "not inserted, ")))
                  (setq blpth (cdr (assoc 1 bldat)))
                  (setq namlst (cons (strcat blnam reso blpth) namlst)))))
 namlst)
 ; Ŀ
 ;   Cxlis end.                                                            
 ; 

 ; Ŀ
 ;   XXlis.                                                                
 ; 
 (DEFUN C:XXLIS (/ filnam fnam *error* lista fn sub str)
  (setvar "cmdecho" 0)
  (setq filnam "c:\\xxrefs.txt")
  (setq fnam (getvar "dwgname"))
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
  (if regist (regist (strcat "***** Error in XXlis.lsp, File: " fnam)))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Get a list of all xrefs.                                              
 ; 
  (setq lista (cxlis))
 ; Ŀ
 ;   Write them to the file.                                               
 ; 
  (setq fn (open filnam "a"))
  (write-line (strcat "\nXrefs in drawing " fnam) fn)
  (while (setq sub (car lista))
         (setq lista (cdr lista))
         (write-line sub fn))
  (write-line "Xrefs End" fn)
  (close fn)
 (princ))