 ; Ŀ
 ;   Imik - kill all unreferenced images.                                  
 ;   Copyright 2014 by Rocket Software Ltd.                                
 ;   See Klim which kills all images.                                      
 ;                                                                         
 ; 

 ; Ŀ
 ;   Iget - get a list of all image definitions:                           
 ;   (definition_ename  name_and_path  name)                               
 ;   Takes no arguments, calls nothing.                                    
 ; 
 (DEFUN IGET (/ dist imdic sub iname ientt ipath suba malis)
  (setq dict (entget (namedobjdict)))     ; all dictionaries
  (setq imdic (dictsearch (namedobjdict) "acad_image_dict"))
  (while (setq sub (car imdic))
         (setq imdic (cdr imdic))
         (if (= (car sub) 3)
             (progn
                  (setq iname (cdr sub))
                  (setq ientt (cdr (car imdic)))
                  (setq imdic (cdr imdic))
                  (setq ipath (cdr (assoc 1 (entget ientt))))
                  (setq suba (list ientt ipath iname))
                  (setq malis (cons suba malis)))))
 malis)
 ; Ŀ
 ;   Iget end.                                                             
 ; 

 ; Ŀ
 ;   Imik.                                                                 
 ; 
 (DEFUN C:IMIK (/ imlis ss num enam entt imenam liss sub)
  (if (and (setq ss (ssget "x" (list (cons 0 "image"))))
           (setq imlis (iget)))                    ; all image definition enames
      (progn
           (setq num 0)
           (while (setq enam (ssname ss num))
                  (setq num (1+ num))
                  (setq entt (entget enam))
                  (setq imenam (cdr (assoc -1 (entget (cdr (assoc 340 entt))))))
                  (setq liss (cons imenam liss)))  ; referenced imagedef enames
           (setq num 0)
           (while (setq sub (nth num imlis))
                  (setq num (1+ num))
                  (setq enam (car sub))
                  (if (not (member enam liss))
                      (entdel enam)))))
 (princ))